//
// Sample program: dynmem1.sc
//
// demo: dynamic memory handling: getmem, getmemsz
//
// (C) Copyright 1998, David Moore.
//


#include "jxlib.sh"


module test;

  declare;
     byte stk[1023];
     byte stktop;

     byte task1name "task_1\0";

     long tid;
     byte msg "allocated 200 bytes\n\0";

     byte smem "Free memory size = ";
     byte smemx[11];

     byte smemallo "Memory allocation starts at = ";
     byte smemallox[11];

     long memsz;
     long memallo;

     public proc main( void );
     public proc main_cli( void );
     public proc task1( void );
  
  enddeclare;

  public proc main( void );

     tid = lib_taskcreate( ptr task1, ptr stktop, 21, ptr task1name );

  endproc;



  public proc main_cli( void );
  endproc;



  public proc task1( void );

    // get available free memory
    memsz = lib_getmemsz();
    lib_bin2azstr( memsz, ptr smemx );
    lib_write( ptr smem );
    lib_scrollup( 1 );

    // allocate some of it
    memallo = lib_getmem( 200 );
    lib_bin2azstr( memallo, ptr smemallox );
    lib_write( ptr smemallo );
    lib_scrollup( 1 );


    // get free memory size after allocation
    memsz = lib_getmemsz();
    lib_fillz( ptr smemx, 11 );
    lib_bin2azstr( memsz, ptr smemx );
    lib_write( ptr smem );
    lib_scrollup( 1 );

    // allocate some more memory
    memallo = lib_getmem( 200 );
    lib_bin2azstr( memallo, ptr smemallox );
    lib_write( ptr smemallo );
    lib_scrollup( 1 );

    lib_write( ptr msg );

    // get free memory size after allocation
    memsz = lib_getmemsz();
    lib_fillz( ptr smemx, 11 );
    lib_bin2azstr( memsz, ptr smemx );
    lib_write( ptr smem );
    lib_scrollup( 1 );

    // write to allocated memory

    map byte_value bxs = memallo;
    bxs[1] = 65;


    lib_taskdeletev();

  endproc;    



endmodule;

 
