//   
// This work is (C) Copyright, 1998 by David Moore, Belfast, N.Ireland
// All rights reserved.
//
// Jxlib.sh Joshua run time library header file
//
//
// Header file software version: BETA=001 (snowcat)
//
//
// History:
//
//   D.M.               Made final modifications for snowcat release.
//
//   D.M.  DEC-98       Update for snowcat build 2
//
//

// constants

// foreground colours

#define fc_black  00h
#define fc_blue   01h
#define fc_green  02h
#define fc_cyan   03h
#define fc_red    04h
#define fc_mag    05h
#define fc_brown  06h
#define fc_white  07h

// background colours

#define bc_black  00h
#define bc_blue   10h
#define bc_green  20h
#define bc_cyan   30h
#define bc_red    40h
#define bc_mag    50h
#define bc_brown  60h
#define bc_white  70h

// attributes

#define ac_flash  80h  
#define ac_steady 00h


// task management

extern func long lib_taskcreate( long p_cd, long p_stk, long prio, long 12aznameor0 );
extern proc lib_taskdelete( void );
extern proc lib_setprio( byte prio );
extern func long lib_getprio( void );
extern proc lib_taskdeletev( void );        
extern proc lib_sleep( long nticks );

// synchronization

extern func long lib_getsem( long initval, long p_8asname );
extern proc lib_waitsem( long p_8asname );
extern proc lib_signalsem( long p_8asname );

// inter-process communication NB not in beta

extern func long lib_ipcopen( long p_as8nameor0 );
extern func long lib_ipcnm2id( long p_as8name );
extern proc lib_ipcclose( long portid );
extern proc lib_ipcwrite( long portid, long data );
extern func long lib_ipcread( long portid, long tmotc );
extern proc lib_ipcintrwrite( long portid, long data );


// dynamic memory management

extern func long lib_getmem( long reqbytes );
extern func long lib_getmemsz( void );

// time - measurement (100ths sec) non-reentrant

extern proc lib_elstart( void );
extern func long lib_elstop( void );

// time - wall clock time

extern proc lib_rdrtc( long p_6bcdtm );
extern proc lib_tm2str( long p_bcdtm, long p_az18 );

// console input

extern func byte lib_waitkey( void );
extern func byte lib_waitkeye( byte flash, byte y, byte x );

// console output

extern proc lib_write( long p_azstr );
extern proc lib_writeat( byte flash, byte y, byte x, long p_azstr );
extern proc lib_writecolat( byte flash, byte bc, byte fc, byte y, byte x, long p_azstr );
extern proc lib_cls( void );
extern proc lib_clscol( byte bc );
extern proc lib_scrollup( byte n );
extern proc lib_curpos( byte y, byte x );
extern proc lib_curoff( void );
extern proc lib_curon( void );
extern proc lib_setcol( byte bc, byte fc );

// sound (speaker)

extern proc lib_beep( void );
extern proc lib_tone( long duration, long freqhz );


// system

extern proc lib_haltsys( long swhaltcode );
extern proc lib_rebootsys( void );
extern func long lib_rdkernelcfg( void );
extern proc lib_install_intr( byte p_intrno, long p_intrcd );
extern proc lib_intr_mask( byte intr2mask );
extern proc lib_intr_umask( byte intr2umask );
extern proc lib_eoi( byte intr );

// string and conversion routines

extern proc lib_fillc( long p_buf, byte c, long bufcnt );
extern proc lib_fillz( long p_buf, long bufcnt );
extern proc lib_bin2str( long binval, long p_as10 );
extern proc lib_bin2azstr( long binval, long p_az11 );
extern proc lib_byte2str( byte bval, long p_as2 );
extern proc lib_byte2azstr( byte bval, long p_az3 );
extern proc lib_w2hexstr( long binval, long p_as4 );
extern proc lib_w2azhexstr( long binval, long p_az5 );
extern proc lib_bin2hex( long binval, long p_as8 );
extern proc lib_bin2azhex( long binval, long p_az9 );
extern proc lib_stradd( long p_asdest, long p_azadd );
extern func long lib_strlen( long p_azstr );
extern func long lib_strcmp( long p_azs1, long p_azs2 );

// serial interface (sxd lite interface for beta)

extern proc lib_sx1cfg( long baseaddr );
extern proc lib_sx2cfg( long baseaddr );
extern proc lib_sx1setbaud( long baudrate );
extern proc lib_sx2setbaud( long baudrate );
extern proc lib_sxinit( void );
extern proc lib_sx1ping( byte outbyte );
extern proc lib_sx2ping( byte outbyte );

// lp interface (lxd)

extern proc lib_lp1cfg( long baseaddr );
extern proc lib_lp1writeaz( long p_azstr );
extern proc lib_lp1writen( long p_as, long nbytes );
extern proc lib_lp1eoj( void );


// [end] jxlib.sh


