//
// Sample program: serial2.sc
//
// Demo: Transmit ascii data to rs232 port.
//       If you have the hardware (null modem wiring) and software (termemu)
//       you can watch the ascii data pop up on a remote display
//
// (C) Copyright 1998, David Moore.
//
//--- Modification History:
//
// D.M   DEC-98         This file replaces the serial.sc that appeared with
//                      build 1. It is modified to take advantage of
//                      jxos.lo build 2
//

#include "jxlib.sh"

module test;

  declare;

     byte stk[1023];
     byte stktop;

     byte task1name "task_1\0";

     byte start_str "Serial ping demo.\n\0";
     byte instr_str "Sends keystrokes to com2=9600,8,1,n until keystroke=0.\n\0";
     byte exit_str "Done -- exiting.\n\0";

     long tid;
     long sts;
     byte key;

     public proc main( void );
     public proc main_cli( void );
     public proc task1( void );
  
  enddeclare;


  public proc main( void );
     lib_setcol( bc_blue, fc_white );
     lib_clscol( bc_blue );
     tid = lib_taskcreate( ptr task1, ptr stktop, 21, ptr task1name );
  endproc;



  public proc main_cli( void );
  endproc;



  public proc task1( void );

    key = 0;
  
    // Configure base address of com2 - may be different on your machine.
    // Find out using w95 Control Panel, or w3.1 msd.exe or Bios setup.

    lib_sx2cfg( 2f8h );

    // set port to 19200,8,1,N
    
    lib_sx2setbaud( 19200 );
    lib_sxinit();

    lib_write( ptr start_str );
    lib_write( ptr instr_str );

    while( key <> 48 );

      key = lib_waitkey();
      lib_sx2ping( key );

      // send crlf
      if( key = 13 );        
        lib_sx2ping( 10 );
        lib_sx2ping( 13 );
      endif;

    endwhile;

    lib_write( ptr exit_str );
        
    lib_taskdeletev();

  endproc;    


endmodule;

